# Source Generated with Decompyle++
# File: in.pyo (Python 2.5)

import dns.name as dns
import dns.rdataset as dns
import dns.rdataclass as dns
import dns.renderer as dns

class RRset(dns.rdataset.Rdataset):
    __slots__ = [
        'name',
        'deleting']
    
    def __init__(self, name, rdclass, rdtype, covers = dns.rdatatype.NONE, deleting = None):
        super(RRset, self).__init__(rdclass, rdtype)
        self.name = name
        self.deleting = deleting

    
    def _clone(self):
        obj = super(RRset, self)._clone()
        obj.name = self.name
        obj.deleting = self.deleting
        return obj

    
    def __repr__(self):
        if self.covers == 0:
            ctext = ''
        else:
            ctext = '(' + dns.rdatatype.to_text(self.covers) + ')'
        if self.deleting is not None:
            dtext = ' delete=' + dns.rdataclass.to_text(self.deleting)
        else:
            dtext = ''
        return '<DNS ' + str(self.name) + ' ' + dns.rdataclass.to_text(self.rdclass) + ' ' + dns.rdatatype.to_text(self.rdtype) + ctext + dtext + ' RRset>'

    
    def __str__(self):
        return self.to_text()

    
    def __eq__(self, other):
        if not isinstance(other, RRset):
            return False
        
        if self.name != other.name:
            return False
        
        return super(RRset, self).__eq__(other)

    
    def match(self, name, rdclass, rdtype, covers, deleting = None):
        if not super(RRset, self).match(rdclass, rdtype, covers):
            return False
        
        if self.name != name or self.deleting != deleting:
            return False
        
        return True

    
    def to_text(self, origin = None, relativize = True, **kw):
        return super(RRset, self).to_text(self.name, origin, relativize, self.deleting, **kw)

    
    def to_wire(self, file, compress = None, origin = None, **kw):
        return super(RRset, self).to_wire(self.name, file, compress, origin, self.deleting, **kw)

    
    def to_rdataset(self):
        return dns.rdataset.from_rdata_list(self.ttl, list(self))



def from_text_list(name, ttl, rdclass, rdtype, text_rdatas):
    if isinstance(name, (str, unicode)):
        name = dns.name.from_text(name, None)
    
    if isinstance(rdclass, str):
        rdclass = dns.rdataclass.from_text(rdclass)
    
    if isinstance(rdtype, str):
        rdtype = dns.rdatatype.from_text(rdtype)
    
    r = RRset(name, rdclass, rdtype)
    r.update_ttl(ttl)
    for t in text_rdatas:
        rd = dns.rdata.from_text(r.rdclass, r.rdtype, t)
        r.add(rd)
    
    return r


def from_text(name, ttl, rdclass, rdtype, *text_rdatas):
    return from_text_list(name, ttl, rdclass, rdtype, text_rdatas)


def from_rdata_list(name, ttl, rdatas):
    if isinstance(name, (str, unicode)):
        name = dns.name.from_text(name, None)
    
    if len(rdatas) == 0:
        raise ValueError, 'rdata list must not be empty'
    
    r = None
    for rd in rdatas:
        if r is None:
            r = RRset(name, rd.rdclass, rd.rdtype)
            r.update_ttl(ttl)
            first_time = False
        
        r.add(rd)
    
    return r


def from_rdata(name, ttl, *rdatas):
    return from_rdata_list(name, ttl, rdatas)

